<?php
//
// Nagios Core Passive Check NRDP Plugin
// Copyright (c) 2010 Nagios Enterprises, LLC.
// License: Nagios Open Software License <http://www.nagios.com/legal/licenses>
//
// $Id: utils.inc.php 12 2010-06-19 04:19:35Z egalstad $

// This plugin must replace the default nagioscorepassivecheck provided with default nrdp server

// Prise en charge de centreon car obsolecence de result_dir
// utilisation de la fonctionnalit "External Command File" (/var/lib/centreon-engine/rw/centengine.cmd)
// pour grer les mises  jour des infos de l'host/service 

// Support for Centreon with obsolecence of result_dir
// using now external command file (default to /var/lib/centreon-engine/rw/centengine.cmd)
// to handle updates of hosts or services state.

require_once(dirname(__FILE__).'/../../config.inc.php');
require_once(dirname(__FILE__).'/../../includes/utils.inc.php');


register_callback(CALLBACK_PROCESS_REQUEST,'centreon_process_request');


function centreon_process_request($cbtype,$args){

	$cmd=grab_array_var($args,"cmd");
	
	//echo "CMD=$cmd<BR>";
	
	switch($cmd){
		// check data
		case "submitcheck":
			centreon_submit_check_data();
			break;
		// something else we don't handle...
		default:
			break;
		}
	}

function centreon_submit_check_data()
{
	global $cfg;
	global $request;
	
	$debug = false;
	
	if($debug)
	{
		echo "REQUEST:<BR>";
		print_r($request);
		echo "<BR>";
	}
	
	// check results are passed as XML data
	$xmldata=grab_request_var("XMLDATA");
	
	if($debug)
	{
		echo "XMLDATA:<BR>";
		print_r($xmldata);
		echo "<BR>";
	}
	
	// make sure we have data
	if(!have_value($xmldata))
	{
		handle_api_error(ERROR_NO_DATA);
	}	
	
	// convert to xml
	$xml=@simplexml_load_string($xmldata);
	if(!$xml)
	{
		print_r(libxml_get_errors());
		handle_api_error(ERROR_BAD_XML);
	}
		
	if($debug)
	{
		echo "OUR XML:<BR>";
		print_r($xml);
		echo "<BR>";
	}

	// make sure we can write to check command file
	if(!isset($cfg["command_file"]))
	{
		handle_api_error(ERROR_COMMAND_FILE_NOT_SET);
	}
	if(!file_exists($cfg["command_file"]))
	{
		handle_api_error(ERROR_NO_COMMAND_FILE);
	}
		
	$total_checks=0;
	
	$cmdOutput = array(
				'host' => '',
				'svc' => '',
			
			);
	
	// process each result
	foreach($xml->checkresult as $cr)
	{
	
		// get check result type
		$type="host";
		foreach($cr->attributes() as $var => $val)
		{
			if($var=="type")
			{
				$type=strval($val);
			}
			
			// common elements
			$hostname=strval($cr->hostname);
			$state=intval($cr->state);
			$output=strval($cr->output);
			
			// service checks
			if($type=="service")
			{
				$servicename=strval($cr->servicename);
			}
				
				
			/*
			 * BUILDING COMMAND FILE OUTPOUT
			 */
			
			
			switch ($type) 
			{
				case "host":
					//syntaxe check host :
					//[epoch] PROCESS_HOST_CHECK_RESULT;<host_name>;<status_code>;<plugin_output>
					$ts = time();
					$cmdOutput['host'] .= '[' . $ts . '] ' .  'PROCESS_HOST_CHECK_RESULT;' ;
					$cmdOutput['host'] .= $hostname . ';' ;
					$cmdOutput['host'] .= $state . ';' ;
					$cmdOutput['host'] .= $output  ;
					$cmdOutput['host'] .= "\n";
					break;
			
				case "service":
					//syntaxe check service:
					//[epoch]  PROCESS_SERVICE_CHECK_RESULT;<host_name>;<service_description>;<return_code>;<plugin_output>
					$ts = time();
					$cmdOutput['svc'] .= '[' . $ts . '] ' . 'PROCESS_SERVICE_CHECK_RESULT;' ;
					$cmdOutput['svc'] .= $hostname . ';' ;
					$cmdOutput['svc'] .= $servicename . ';' ;
					$cmdOutput['svc'] .= $state . ';' ;
					$cmdOutput['svc'] .= $output  ;
					$cmdOutput['svc'] .= "\n";
					break;
					
					
				
				// something else we don't handle...
				default:
					handle_api_error(ERROR_BAD_CHECK_TYPE);
					break;
			}
			
			$total_checks++;
		}
	}
	////// WRITE THE CHECK RESULT //////
	
	if($debug)
	{
		echo "--- HOST CHECK RESULT  :---<BR>";
		echo $cmdOutput['host'] . '<BR>';
		echo "--- SERVICE CHECK RESULT : ---<BR>";
		echo $cmdOutput['svc'] . '<BR>';
	}
	
	/*
	 * Ecritures des donnes dans le fichier de commande nagios
	 */
	
	// open external command file, les test prcdents en vrifie la prsence
	$fh = fopen($cfg["command_file"],"w+");
	if ($fh === false)
	{
		handle_api_error(ERROR_COMMAND_FILE_OPEN);
	}
	
	//criture des donnes dans le fichier de commande pour HOST
	if (have_value($cmdOutput['host']))
	{
		if (fwrite($fh,$cmdOutput['host']) === false )
		{
			handle_api_error(ERROR_COMMAND_FILE_OPEN_WRITE);
		}
	}

	//criture des donnes dans le fichier de commande pour SERVICES
	if (have_value($cmdOutput['svc']))
	{
		if (fwrite($fh,$cmdOutput['svc']) === false )
		{
			handle_api_error(ERROR_COMMAND_FILE_OPEN_WRITE);
		}
	}
	
	fclose($fh);
			
	output_api_header();
	
	echo "<result>\n";
	echo "  <status>0</status>\n";
	echo "  <message>OK</message>\n";
	echo "    <meta>\n";
	echo "       <output>".$total_checks." checks processed.</output>\n";
	echo "    </meta>\n";
	echo "</result>\n";
	
	exit();
}


	

?>